
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Choice;
import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.List;
import javax.microedition.lcdui.StringItem;

/**
 * Entre 2 Almas	[https://sourceforge.net/projects/entre2almas/]  
 * ------------------------------------------------------------------------
 * This file is part of "Entre 2 Almas".
 * "Entre 2 Almas" is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * "Entre 2 Almas" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "Entre 2 Almas"; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * ------------------------------------------------------------------------
 * 		Copyright 2005 - 2006 Pedro Javier Sez Martnez
 * 
 * 
 * Es el men de alto nivel, los cuales se adaptan a las cualidades de los
 * propios mviles.
 * 
 * @author Pedro Javier Sez Martnez
 * @version 1.0
 */
public class UITerminalST extends Canvas implements UIFactory, CommandListener {

	/**
	 * Midlet del juego
	 */
	private Entre2Almas midlet;

	/**
	 * Manejador de la pantalla
	 */
	private Display display;

	/**
	 * Comando volver, el cual tendr prioridad 0.Se utiliza en la pantalla de
	 * ayuda, de opciones y de memoria
	 */
	private Command volverCommand = new Command("Volver", Command.BACK, 0);

	/**
	 * Comando Salir, el cual tendr prioridad 0.Se utiliza en el men principal
	 */
	private Command salirCommand = new Command("Salir", Command.EXIT, 0);

	/**
	 * Comando aceptar, el cual tendr prioridad 1.Se utiliza en la pantalla de
	 * opciones
	 */
	private Command acceptCommand = new Command("Aceptar", Command.BACK, 1);

	/**
	 * Lista que ser utilizada para mostrar las opciones de los distintos
	 * mens.
	 */
	List opciones;

	/**
	 * Formulario en que se mostrarn StringItems y dems.
	 */
	Form formulario;

	/**
	 * ChoiceGroup utilizado en la pantalla de opciones.
	 */
	ChoiceGroup opcionOpciones;

	/**
	 * Mensaje que se mostrar en la ayuda y en el acerca de... Un StringItem va
	 * dentro de un Form
	 */
	StringItem mensaje;

	/**
	 * Constructor de la clase que representa el interfaz clsico
	 */
	public UITerminalST(Entre2Almas midlet) {
		this.midlet = midlet;
		this.display = midlet.getDisplay();
		opciones = new List(" ", Choice.IMPLICIT);
		formulario = new Form(" ");
		String[] estados = { Utils.tiposMenu[0], Utils.tiposMenu[1] };
		opcionOpciones = new ChoiceGroup(Utils.tiposMenuTxt, List.EXCLUSIVE,
				estados, null);
		opcionOpciones.setLayout(ChoiceGroup.LAYOUT_NEWLINE_BEFORE);
		opcionOpciones.setSelectedIndex(midlet.tipoMenu, true);
		mensaje = new StringItem(null, " ");
	}

	/**
	 * Dibuja la pantalla del men principal
	 * 
	 * @param g
	 *            objeto Graphics
	 */
	public void getMenuPrincipal(Graphics g) {
		Utils.cargada = Utils.menuPrin;
		//Vaciamos el contenido de opciones
		opciones.deleteAll();
		opciones.setTitle(Utils.titulo);
		//Aadimos las opciones disponibles a la lista.
		if (Utils.jugando)
			//Si estamos jugando, activamos la opcin de seguir jugando,
			//la cual est situada en la posicin 0 de el array opMenuPrin
			opciones.append(Utils.opMenuPrin[0], null);

		//aadimos el resto de opciones
		for (int i = 1; i < Utils.opMenuAyuda.length; i++)
			opciones.append(Utils.opMenuPrin[i], null);

		opciones.removeCommand(volverCommand);
		opciones.removeCommand(acceptCommand);
		//	Aadimos a la pantalla los comandos elegir y salir.
		//opciones.addCommand(selectCommand);
		opciones.addCommand(salirCommand);
		int i = Utils.menuPrinIdx;
		if (Utils.jugando)
			opciones.setSelectedIndex(Utils.menuPrinIdx, true);
		else {
			if (Utils.menuPrinIdx > 0)
				opciones.setSelectedIndex(Utils.menuPrinIdx - 1, true);
		}
		opciones.setCommandListener(this);
		display.setCurrent(opciones);
	}

	/**
	 * Muestra las opciones que hay dentro de "Memoria"
	 * 
	 * @param g
	 *            Objeto Graphics
	 */
	public void getPantallaMemoria(Graphics g) {
		Utils.cargada = Utils.memoria;
		//vaciamos el contenido de la lista opciones
		opciones.deleteAll();
		//El titulo coincidir con el nombre que tiene en el men principal
		opciones.setTitle(Utils.opMenuPrin[Utils.menuPrinIdx]);
		opciones.removeCommand(salirCommand);
		//opciones.removeCommand(selectCommand);
		opciones.addCommand(volverCommand);
		//opciones.addCommand(selectCommand);
		opciones.setCommandListener(this);
		//establecemos las opciones de la pantalla memoria
		if (Utils.jugando)
			opciones.append(Utils.opMenuMemo[0], null);
		opciones.append(Utils.opMenuMemo[1], null);
		display.setCurrent(opciones);
	}

	/**
	 * Dibuja el contenido de la pantalla "Opciones"
	 * 
	 * @param g
	 *            Objeto Graphics
	 */
	public void getPantallaOpciones(Graphics g) {
		Utils.cargada = Utils.opcion;
		formulario.deleteAll();
		//		El titulo coincidir con el nombre que tiene en el men principal
		formulario.setTitle(Utils.opMenuPrin[Utils.menuPrinIdx]);
		opcionOpciones.setSelectedIndex(midlet.tipoMenu, true);
		formulario.append(opcionOpciones);
		formulario.removeCommand(volverCommand);
		formulario.addCommand(acceptCommand);
		formulario.setCommandListener(this);
		display.setCurrent(formulario);
	}

	/**
	 * Dibuja el contenido de la "Ayuda"
	 * 
	 * @param g
	 *            Objeto Graphics
	 */
	public void getPantallaAyuda(Graphics g) {
		Utils.cargada = Utils.ayuda;
		//Vaciamos el contenido de opciones
		opciones.deleteAll();
		//		El titulo coincidir con el nombre que tiene en el men principal
		opciones.setTitle(Utils.opMenuPrin[Utils.menuPrinIdx]);
		//Aadimos las opciones disponibles a la lista.
		for (int i = 0; i < Utils.opMenuAyuda.length; i++)
			opciones.append(Utils.opMenuAyuda[i], null);
		opciones.removeCommand(salirCommand);
		opciones.addCommand(volverCommand);
		opciones.setSelectedIndex(Utils.menuAyudaIdx, true);
		opciones.setCommandListener(this);
		display.setCurrent(opciones);
	}

	/**
	 * Dibuja el contenido de la "Ayuda"
	 * 
	 * @param g
	 *            Objeto Graphics
	 */
	public void getPantallaSubAyuda(Graphics g) {
		Utils.cargada = Utils.parteMenu;
		formulario.deleteAll();
		//Dependiendo de la opcin de ayuda en la que nos encontramos, le
		// ponemos
		//uno u otro titulo y uno u otro texto.
		formulario.setTitle(Utils.opMenuAyuda[Utils.menuAyudaIdx]);
		mensaje.setText(Utils.txtSubAyuda[Utils.menuAyudaIdx]);

		formulario.append(mensaje);
		formulario.removeCommand(acceptCommand);
		formulario.addCommand(volverCommand);
		formulario.setCommandListener(this);
		display.setCurrent(formulario);
	}

	/**
	 * Muestra el contenido de la "Acerca de..."
	 * 
	 * @param g
	 *            Objeto Graphics
	 */
	public void getPantallaAcerca(Graphics g) {
		Utils.cargada = Utils.acerca;
		formulario.deleteAll();
		formulario.setTitle(Utils.opMenuPrin[Utils.menuPrinIdx]);
		//StringItem que se mostrar en el form y que contiene
		//lo que mostraremos en la ayuda
		mensaje.setText(Utils.conteAcerca);
		formulario.append(mensaje);
		formulario.removeCommand(acceptCommand);
		formulario.addCommand(volverCommand);
		formulario.setCommandListener(this);
		display.setCurrent(formulario);
	}

	/**
	 * Cuando se pulsa un comando, viene a este mtodo.
	 */
	public void commandAction(Command c, Displayable d) {
		switch (Utils.parteMenu) {
		case Utils.menuPrin:
			if (c == salirCommand) {
				midlet.salir();
			} else {//El nico comando que queda es el botn central de select
				int aux = opciones.getSelectedIndex();
				if (!Utils.jugando)
					aux = aux + 1;
				switch (aux) {
				case 0://Seguir Jugando
					midlet.seguirJugando();
					break;
				case 1://Nueva Partida
					midlet.IniciarPartida();
					break;
				case 2://Memoria
					Utils.menuPrinIdx = 2;
					Utils.parteMenu = Utils.memoria;
					break;
				case 3://Opciones
					Utils.menuPrinIdx = 3;
					Utils.parteMenu = Utils.opcion;
					break;
				case 4://Ayuda
					Utils.menuPrinIdx = 4;
					Utils.parteMenu = Utils.ayuda;
					break;
				case 5://Acerca de...
					Utils.menuPrinIdx = 5;
					Utils.parteMenu = Utils.acerca;
					break;
				}
				//si no pones delante el display.setCurrent(this) no tira
				//el repaint(), ya que en ese momento el display tendr como
				//objeto Displayable un List y el repaint solo llama al
				//paint si el display tiene como Displayable un canvas.
				if (aux > 1) {//Si no quiere ni seguir partida ni nueva partida
					display.setCurrent(this);
					repaint();
				}
			}

			break;
		case Utils.memoria:
			if (c == volverCommand) {
				Utils.parteMenu = Utils.menuPrin;
				display.setCurrent(this);
				repaint();
			} else {
				int aux = opciones.getSelectedIndex();
				if (!Utils.jugando)
					aux = aux + 1;
				switch (aux) {
				case 0://Guardar Partida
					if (midlet.puedeGuardar()) {
						Utils.guardandoPartida = true;
						midlet.seguirJugando();
					} else
						midlet
								.mostrarAlerta(
										"Mientras en la partida ests en un video, "
												+ "en una conversacin, o se este mostrando un mensaje, no se podr guardar "
												+ "la partida", AlertType.INFO);
					break;
				case 1://Cargar Partida
					if (midlet.hayGuardada()) {
						Utils.cargandoPartida = true;
						midlet.IniciarPartida();
					} else
						midlet
								.mostrarAlerta(
										"No hay ninguna partida guardada, la cual se pueda cargar.",
										AlertType.INFO);
					break;
				}

			}
			break;
		case Utils.ayuda:
			if (c == volverCommand)
				Utils.parteMenu = Utils.menuPrin;
			else {//El nico comando que queda es el botn central de select
				int aux = opciones.getSelectedIndex();
				switch (aux) {
				case 0:
					Utils.menuAyudaIdx = 0;
					Utils.parteMenu = Utils.ayudaTematica;
					break;
				case 1:
					Utils.menuAyudaIdx = 1;
					Utils.parteMenu = Utils.ayudaTeclas;
					break;
				case 2:
					Utils.menuAyudaIdx = 2;
					Utils.parteMenu = Utils.ayudaVideo;
					break;
				case 3:
					Utils.menuAyudaIdx = 3;
					Utils.parteMenu = Utils.ayudaInventario;
					break;
				case 4:
					Utils.menuAyudaIdx = 4;
					Utils.parteMenu = Utils.ayudaMapa;
					break;
				case 5:
					Utils.menuAyudaIdx = 5;
					Utils.parteMenu = Utils.ayudaConversacion;
					break;
				}
			}
			display.setCurrent(this);
			repaint();
			break;
		case Utils.acerca:
			if (c == volverCommand) {
				Utils.parteMenu = Utils.menuPrin;
				display.setCurrent(this);
				repaint();
			}
			break;
		case Utils.opcion:
			if (c == acceptCommand) {
				midlet.tipoMenu = opcionOpciones.getSelectedIndex();
				Utils.parteMenu = Utils.menuPrin;
				midlet.setMenuRs();
				midlet.menu();
			}
			break;
		default:
			if (c == volverCommand) {
				Utils.parteMenu = Utils.ayuda;
				display.setCurrent(this);
				repaint();
			}
			break;
		}
	}

	/**
	 * Mtodo llamado por el display cuando pone en pantalla este Canvas
	 */
	protected void paint(Graphics g) {
		if (Utils.cargada != Utils.parteMenu) {
			switch (Utils.parteMenu) {
			case Utils.menuPrin://Men principal
				getMenuPrincipal(g);
				break;
			case Utils.memoria://Memoria:
				getPantallaMemoria(g);
				break;
			case Utils.ayuda://Ayuda
				getPantallaAyuda(g);
				break;
			case Utils.acerca://Acerca de...
				getPantallaAcerca(g);
				break;
			case Utils.opcion://opciones
				getPantallaOpciones(g);
				break;
			default:
				getPantallaSubAyuda(g);
				break;
			}
		}
	}

}
