
import java.io.IOException;
import java.util.Vector;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Image;

/**
 * Entre 2 Almas	[https://sourceforge.net/projects/entre2almas/]  
 * ------------------------------------------------------------------------
 * This file is part of "Entre 2 Almas".
 * "Entre 2 Almas" is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * "Entre 2 Almas" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "Entre 2 Almas"; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * ------------------------------------------------------------------------
 * 		Copyright 2005 - 2006 Pedro Javier Sez Martnez
 * 
 * 
 * Clase esttica que se encargar de mantener algunas variables comunes a todas
 * las clases, y a realizar tareas repetitivas.
 * 
 * @author Pedro Javier Sez Martnez
 * @version 1.0
 */
public class Utils {

	/**
	 * Habr dos tamaos de imgenes, dependiendo del tamao de pantalla del
	 * mvil. As tendremos 2 grupos: El de 128x128 --> Aquellos mviles con
	 * pantallas iguales o superiores a 128x128 --> Su valor int es 0 El de
	 * 176x200 --> Aquellos mviles con pantallas iguales o superiores a 176x200
	 * --> Su valor int es 1
	 */
	static int grupo;

	/**
	 * Solo habr una imagen cargada en cada momento, cada imagen puede contener
	 * los frames de muchos sprites, lo cual hace que sean muy grandes y por eso
	 * solo se mantiene una cargada en memoria.
	 */
	static Image imagen = null;

	/**
	 * Adems tambin se guardan sus datos de alto y ancho de cada uno de los
	 * frames que la forman.
	 */
	static int anchoIm, altoIm = 0;

	/**
	 * Y tambin el nombre que tiene la imagen, para as saber cual tenemos
	 * creada y as puede que nos encontremos con casos en los que no es
	 * necesarios cargar la imagen porque ya esta cargada
	 */
	static StringBuffer nomImagen = new StringBuffer();

	//Array de imgenes que contiene descripciones de imgenes cuyos parmetros
	// son:
	//Antes del primer punto y coma se indicar la ruta de la imagen
	//despus se indicar el ancho de cada uno de los frames de la imagen
	//y por ultimo se indicar el alto de cada uno de los frames de la imagen

	/**
	 * Array de imgenes que contiene descripciones de imgenes cuyos parmetros
	 * son: Antes del primer punto y coma se indicar la ruta de la imagen
	 * despus se indicar el ancho de cada uno de los frames de la imagen y por
	 * ultimo se indicar el alto de cada uno de los frames de la imagen
	 */
	static String[] imagenes;

	//imgenes necesarias para el juego.
	static String splash, imMenuPrin;

	static String imOpciones;

	static String imMemoria;

	static String imAyuda;

	static String imAcerca;

	static String spCargando;

	static String imGuardando;

	static String spPuntero;

	static String imPunCami;

	static String spOscarLado;

	static String spOscarEspa;

	static String spOscarFren;

	static String spOscarCara;

	static String imTmpInv;

	static String[] apariencias;

	//	**************************************************************//
	// 																//
	//		         Variables estticas para la formacin //
	//               de mensajes por pantalla //
	//************************************************************* //
	/**
	 * Fuentes que vamos a utilizar en el men
	 */
	final static Font lowFont = Font.getFont(Font.FACE_MONOSPACE,
			Font.STYLE_PLAIN, Font.SIZE_MEDIUM);

	final static Font highFont = Font.getFont(Font.FACE_MONOSPACE,
			Font.STYLE_BOLD, Font.SIZE_LARGE);

	/**
	 * Ancho de lowFont
	 */
	final static int widthLF = Utils.lowFont.charWidth('a');

	/**
	 * Establecemos el color de las letras del men
	 */
	final static int lowColor = 0xFFFFFFFF;// letras No Iluminada

	final static int highColor = 0x00000000;// letra iluminada

	/**
	 * Altura y anchura a la que se comienzan a imprimir las letras
	 */
	static int startHeight;

	static int startWidth;

	/**
	 * Marca el espacio que se deja para el nombre de los items en la pantalla
	 * de juego, para los mviles de grupo pequeo
	 */
	static final int spaceTextItemPeq = 14;

	/**
	 * Marca el espacio que se deja para el nombre de los items en la pantalla
	 * de juego, para los mviles de grupo grande
	 */
	static final int spaceTextItemGra = 22;

	/**
	 * Delimita el espacio entre lneas de caracteres
	 */
	static int spacing;

	/**
	 * Espacio que se deja para imprimir el mensaje
	 */
	static int spaceMen;

	/**
	 * Numero de lneas que caben en una pantalla para el grupo al que pertenece
	 * el mvil
	 */
	static int numLineas;

	/**
	 * De entre las lneas que forman un mensaje, este atributo define cual se
	 * mostrar primero por pantalla
	 */
	static int linea = 0;

	/**
	 * Mensaje a imprimir
	 */
	static StringBuffer mensaje;

	/**
	 * Numero de lneas que ocupa el mensaje a imprimir
	 */
	static int numLineasMensaje;

	/**
	 * las palabras que forman el mensaje a imprimir
	 */
	static Vector palabrasMensaje;

	/**
	 * Ancho de la pantalla
	 */
	static int width;

	/**
	 * Alto de la pantalla
	 */
	static int height;

	/**
	 * Marca el pxel, a partir del cual empieza la coordenada X del cuadro de
	 * 128x128 o de 176x200, y este cuadro centrado estar en el mvil. Para
	 * establecer su valor se utiliza el primer sprite de tamao 128x128 o
	 * 176x200 (segn grupo) y se aplica la siguiente formula (Utils.width / 2) -
	 * (sprite.getWidth() / 2)
	 */
	static int inicioPantallaX;

	/**
	 * Marca el pxel, a partir del cual empieza la coordenada X del cuadro de
	 * 128x128 o de 176x200, y este cuadro centrado estar en el mvil. Para
	 * establecer su valor se utiliza el primer sprite de tamao 128x128 o
	 * 176x200 (segn grupo) y se aplica la siguiente formula (Utils.height / 2) -
	 * (sprite.getHeight() / 2)
	 */
	static int inicioPantallaY;

	//**************************************************************//
	// 																//
	//		         Variables estticas de los mens //
	//************************************************************* //
	/**
	 * Indica si el juego est en ejecucin, lo cual significa que debemos
	 * mostrar el men con la opcin Seguir Jugando.
	 */
	static boolean jugando = false;

	/**
	 * Indica si se esta cargando una partida guardada con anterioridad.
	 */
	static boolean cargandoPartida = false;

	/**
	 * Indica si se esta guardando una partida.
	 */
	static boolean guardandoPartida = false;

	/**
	 * Indica cual de las opciones del men principal est seleccionada.
	 */
	static int menuPrinIdx;

	/**
	 * Indica cual de las opciones del men ayuda est seleccionada.
	 */
	static int menuAyudaIdx;

	/**
	 * Parte del men en el que nos encontramos
	 */
	public static int parteMenu;

	/**
	 * Almacena el identificador de la pantalla que est actualmente guardada
	 */
	public static int cargada;

	/**
	 * Cada pantalla estar identificada con un entero
	 */
	public static final int menuPrin = 0;

	public static final int memoria = 1;

	public static final int ayuda = 2;

	public static final int acerca = 3;

	public static final int opcion = 4;

	public static final int ayudaTematica = 5;

	public static final int ayudaTeclas = 6;

	public static final int ayudaVideo = 7;

	public static final int ayudaInventario = 8;

	public static final int ayudaMapa = 9;

	public static final int ayudaConversacion = 10;

	public static String titulo;

	/**
	 * Array que almacenar las opciones del men principal.
	 */
	public static String opMenuPrin[] = new String[6];

	/**
	 * Array que almacenar las opciones del men memoria.
	 */
	public static String opMenuMemo[] = new String[2];

	/**
	 * Array que almacenar las opciones del men ayuda.
	 */
	public static String opMenuAyuda[] = new String[6];

	/**
	 * Array que almacenar el texto de cada una de las sub-ayudas.
	 */
	public static String txtSubAyuda[] = new String[6];

	/**
	 * Almacenar el contenido de acerca de...
	 */
	public static String conteAcerca;

	/**
	 * Almacena el nombre de los tipos de men que puede haber - En la posicin
	 * 0 estar el nombre pare el men de alto nivel, el cual est adaptado a la
	 * interfaz nativa de cada mvil. - En la posicin 1 estar el nombre para
	 * el men de bajo nivel, es decir, que ser igual en todos los mviles,
	 * pero es ms colorido, ms bonito, ms vistoso, pero no adaptado a la
	 * interfaz nativa de cada mvil
	 */
	public static String tiposMenu[] = new String[2];

	/**
	 * Nombre de la opcin elegir tipo de men
	 */
	public static String tiposMenuTxt;

	//**************************************************************//
	// 																//
	//		         Variables estticas de la lgica //
	//                          del juego //
	//************************************************************* //
	public static final int reSalir = 0;

	public static final int reMensaje = 1;

	public static final int reAddInvent = 2;

	public static final int reDelInvent = 3;

	public static final int reVideo = 4;

	public static final int reCombinando = 5;

	public static final int reMapa = 6;

	public static final int reIrEstancia = 7;

	public static final int reConversacion = 8;

	public static final int reRespuesta = 9;

	public static final int reRespuOscar = 10;

	public static final int reJuego = 11;

	public static final int reCargaOpSup = 12;

	public static final int reCargaOpInf = 13;

	public static final int reQuitarOp = 14;

	public static final int reQuitarOpYSup = 15;

	public static final int reCamActivaOpIt = 16;

	public static final int reCamActivaOpEs = 17;

	public static final int reCamActivaOpCon = 18;

	public static final int reCamFase = 19;

	public static final int reEliminarItem = 20;

	public static final int reEliminarEstan = 21;

	public static final int reCamNombreIt = 22;

	public static final int reCamNombreEs = 23;

	public static final int reCaminarBlo = 24;

	public static final int reSalirJuego = 25;

	public static final int reCamConsecuCom = 26;

	public static final int reCamConsecuCon = 27;

	public static final int reCamActivaCom = 28;

	public static final int reCambiaEscenario = 29;

	public static final int reCamConsecuIt = 30;

	public static final int reCamConsecuEs = 31;

	public static final int reCambiaVisibleIt = 32;

	public static final int reCambiaVisibleEs = 33;

	public static final int reCaminar = 34;

	public static final int reCamMapa = 35;

	public static final int reCamApariencia = 36;

	public static final int reAddInventSin = 37;

	public static int numOps;

	public static final int aumentaX = 1375;

	public static final int aumentaY = 1631;

	/**
	 * No se podr hacer instancias de la clase.
	 */
	private Utils() {
	}

	/**
	 * Establece el grupo nal que pertenece un mvil, si a los que usaran
	 * imgenes con tamao de 128x128 o a los que usarn las de 176x200
	 * 
	 * @param ancho
	 *            Ancho de la pantalla del mvil
	 * @param alto
	 *            Alto de la pantalla del mvil
	 */
	static public void getGrupo(int ancho, int alto) {
		if (ancho >= 128 && ancho < 176 && alto >= 128 && alto < 200)
			grupo = 0;
		else if (ancho >= 176 && alto >= 200)
			grupo = 1;
	}

	/**
	 * Nos muestra el ancho de pantalla que le corresponde al grupo
	 * 
	 * @return el ancho de pantalla para el grupo
	 */
	static public int getTamGrupoX() {
		if (grupo == 0)
			return 128;
		return 176;//si es de grupo 1...
	}

	/**
	 * Nos muestra el alto de pantalla que le corresponde al grupo
	 * 
	 * @return el alto de pantalla para el grupo
	 */
	static public int getTamGrupoY() {
		if (grupo == 0)
			return 128;
		return 200;//si es de grupo 1...
	}

	/**
	 * Este mtodo devolver la secuencia de frames que forman el objeto pedido.
	 * 
	 * @param peticion
	 *            el sprite que se pide.
	 * @return secuencia de frames que forman el objeto pedido
	 */
	static public int[] getFrames(String peticion) {
		int numFrames = getNumFrames(peticion);
		int[] frames = new int[numFrames];
		int valorInicial = getFrameInicial(peticion);
		for (int i = 0; i < numFrames; i++)
			frames[i] = valorInicial + i;
		return frames;
	}

	/**
	 * Devuelve el frame inicial de un Sprite
	 * 
	 * @param peticion
	 *            el Sprite del que se quiere sacar el frame inicial
	 * @return el frame inicial de un SPrite
	 */
	static public int getFrameInicial(String peticion) {
		int numPunCom = 0;
		//Utilizamos StringBuffer para evitar trabajo extra al recolector
		// de basura
		StringBuffer aux = new StringBuffer();
		for (int i = 0; numPunCom < 2; i++) {
			if (peticion.charAt(i) == ';')
				numPunCom++;
			else if (numPunCom == 1)
				aux.append(peticion.charAt(i));
		}
		//Con el toString transformamos el StringBuffer en una cadena de
		//caracteres.
		return (int) Integer.parseInt(aux.toString());
	}

	/**
	 * Devuelve el numero de frames para una peticin determinada
	 * 
	 * @param peticion
	 *            Sprite del que se quieren saber los frames
	 * @return el numero de frames que tiene ese Sprite
	 */
	static public int getNumFrames(String peticion) {
		int numPunCom = 0;
		int aux = 0;
		for (int i = 0; numPunCom < 2; i++) {
			if (peticion.charAt(i) == ';')
				numPunCom++;
			aux = i;
		}
		return (int) Integer.parseInt(peticion.substring(aux + 1));

	}

	/**
	 * Devuelve los datos de la imagen en la que est almacenada la peticin o
	 * SPrite
	 * 
	 * @param peticion
	 *            Sprite del que se quiere saber la imagen
	 * @return los datos de la imagen en el que esta el Sprite
	 */
	static private String getDatosImagen(String peticion) {
		int auxId = 0;
		while (peticion.charAt(auxId) != ';') {
			auxId++;
		}
		auxId = (int) Integer.parseInt(peticion.substring(0, auxId));
		for (int i = 0; i < imagenes.length; i++) {
			if (getId(imagenes[i]) == auxId) {
				auxId = i;
				i = imagenes.length;
			}
		}
		return imagenes[auxId + grupo];
	}

	/**
	 * Devuelve el identificador de una imagen
	 * 
	 * @param datosImagen
	 *            datos de la imagen de los que se quiere extraer el
	 *            identificador
	 * @return identificador la imagen
	 */
	static private int getId(String datosImagen) {
		int aux = 0;
		while (datosImagen.charAt(aux) != ';') {
			aux++;
		}
		return Integer.parseInt(datosImagen.substring(0, aux));
	}

	/**
	 * Devuelve la ruta de una imagen
	 * 
	 * @param nombreImagen
	 *            datos de la imagen de los que se quiere extraer la ruta
	 * @return ruta de directorios donde est la imagen
	 */
	static private String getRuta(String nombreImagen) {
		int numPunCom = 0;
		//Utilizamos StringBuffer para evitar trabajo extra al recolector
		// de basura
		StringBuffer aux = new StringBuffer();
		for (int i = 0; numPunCom < 2; i++) {
			if (nombreImagen.charAt(i) == ';')
				numPunCom++;
			else if (numPunCom == 1)
				aux.append(nombreImagen.charAt(i));
		}
		//Con el toString transformamos el StringBuffer en una cadena de
		//caracteres.
		return aux.toString();
	}

	/**
	 * Devuelve el ancho de una cada uno de los frame de una imagen
	 * 
	 * @param nombreImagen
	 *            Datos de la imagen.
	 * @return EL ancho de cada uno de los frames de una imagen
	 */
	static private int getAncho(String nombreImagen) {
		int numPunCom = 0;
		//Utilizamos StringBuffer para evitar trabajo extra al recolector
		// de basura
		StringBuffer aux = new StringBuffer();
		for (int i = 0; numPunCom < 3; i++) {
			if (nombreImagen.charAt(i) == ';')
				numPunCom++;
			else if (numPunCom == 2)
				aux.append(nombreImagen.charAt(i));
		}
		//Con el toString transformamos el StringBuffer en una cadena de
		//caracteres.
		return Integer.parseInt(aux.toString());
	}

	/**
	 * Devuelve el alto de una cada uno de los frame de una imagen
	 * 
	 * @param nombreImagen
	 *            Datos de la imagen.
	 * @return EL alto de cada uno de los frames de una imagen
	 */
	static private int getAlto(String nombreImagen) {
		int numPunCom = 0;
		int aux = 0;
		for (int i = 0; numPunCom < 3; i++) {
			if (nombreImagen.charAt(i) == ';')
				numPunCom++;
			aux = i;
		}
		return (int) Integer.parseInt(nombreImagen.substring(aux + 1));

	}

	/**
	 * Carga los datos mas importante de una imagen en la que est el Sprite
	 * solicitado
	 * 
	 * @param nomSprite
	 *            nombre del sprite cuya imagen el la que est contenido se
	 *            quiere cargar
	 */
	static public void cargarImagen(String nomSprite) {
		String datosImagen = getDatosImagen(nomSprite);
		if (!Utils.creada(datosImagen)) {
			nomImagen.delete(0, nomImagen.length());
			nomImagen.append(datosImagen);
			imagen = createImage(Utils.getRuta(datosImagen));
			anchoIm = getAncho(datosImagen);
			altoIm = getAlto(datosImagen);
		}
	}

	/**
	 * Indica si una imagen (que se necesita cargar para un sprite) ya esta
	 * creada. Esto puede pasar porque puede ser que el sprite que se cargo
	 * anteriormente a este, estaba contenido en la misma imagen.
	 * 
	 * @param nombre
	 *            Nombre de la imagen que se quiere cargar
	 * @return si esta creada o no
	 */
	static private boolean creada(String nombre) {
		boolean creada = false;

		if (nomImagen.toString().equals(nombre)) {
			creada = true;
		}
		return creada;
	}

	/**
	 * Mtodo que devuelve un objeto Image a partir de una imagen PNG, la cual
	 * tiene que estar en la carpeta res.
	 * 
	 * @param nombre
	 *            Nombre de la imagen en la carpeta res
	 * @return Image con la imagen ya creada.
	 */
	static private Image createImage(String nombre) {
		try {
			return Image.createImage(nombre);
		} catch (IOException e) {
			System.out.println("error de entrada y salida");
		}
		System.gc();
		return null;
	}

	/**
	 * Devuelve el espacio reservado para el nombre de los Items en la pantalla
	 * de juego, teniendo en cuenta si el mvil es de un grupo u otro
	 * 
	 * @return El espacio reservado para el nombre de los Items en la pantalla
	 *         de juego.
	 */
	static public int getSpaceTextItem() {
		if (grupo == 0)
			return spaceTextItemPeq;
		else
			return spaceTextItemGra;
	}

	/**
	 * Actualiza a la apariencia activa del personaje principal.
	 * 
	 * @param activa
	 *            La apariencia activa del personaje principal
	 */
	static public void actualizarApariencia(int activa) {
		activa = activa * 4;
		Utils.spOscarLado = Utils.apariencias[activa];
		activa++;
		Utils.spOscarEspa = Utils.apariencias[activa];
		activa++;
		Utils.spOscarFren = Utils.apariencias[activa];
		activa++;
		Utils.spOscarCara = Utils.apariencias[activa];
	}

	/**
	 * Devuelve el identificador que corresponde a un determina resultado por
	 * ejemplo a Salir le corresponde reSalir
	 * 
	 * @param resultado
	 *            String con el nombre del resultado.
	 * @return Identificador que corresponde a una determinado resultado
	 */
	public static int getIdResultado(String resultado) {
		if (resultado.equals("Salir"))
			return reSalir;
		if (resultado.equals("Mensaje"))
			return reMensaje;
		if (resultado.equals("Video"))
			return reVideo;
		if (resultado.equals("Mapa"))
			return reMapa;
		if (resultado.equals("Conversacion"))
			return reConversacion;
		if (resultado.equals("Juego"))
			return reJuego;
		if (resultado.equals("Respuesta"))
			return reRespuesta;
		if (resultado.equals("RespuOscar"))
			return reRespuOscar;
		if (resultado.equals("cargaOpSup"))
			return reCargaOpSup;
		if (resultado.equals("cargaOpInf"))
			return reCargaOpInf;
		if (resultado.equals("quitarOp"))
			return reQuitarOp;
		if (resultado.equals("quitarOpYSup"))
			return reQuitarOpYSup;
		if (resultado.equals("salirJuego"))
			return reSalirJuego;
		if (resultado.equals("Caminar"))
			return reCaminar;
		if (resultado.equals("CaminarBlo"))
			return reCaminarBlo;
		if (resultado.equals("CambiaEscenario"))
			return reCambiaEscenario;
		if (resultado.equals("camMapa"))
			return reCamMapa;
		if (resultado.equals("irEstancia"))
			return reIrEstancia;
		if (resultado.equals("combinando"))
			return reCombinando;
		if (resultado.equals("camFase"))
			return reCamFase;
		if (resultado.equals("addInventario"))
			return reAddInvent;
		if (resultado.equals("addInventarioSin"))
			return reAddInventSin;
		if (resultado.equals("delInventario"))
			return reDelInvent;
		if (resultado.equals("camActivaOpIt"))
			return reCamActivaOpIt;
		if (resultado.equals("camActivaOpEs"))
			return reCamActivaOpEs;
		if (resultado.equals("camActivaOpCon"))
			return reCamActivaOpCon;
		if (resultado.equals("eliminarItem"))
			return reEliminarItem;
		if (resultado.equals("eliminarEstan"))
			return reEliminarEstan;
		if (resultado.equals("camNombreIt"))
			return reCamNombreIt;
		if (resultado.equals("camNombreEs"))
			return reCamNombreEs;
		if (resultado.equals("cambiaVisibleIt"))
			return reCambiaVisibleIt;
		if (resultado.equals("cambiaVisibleEs"))
			return reCambiaVisibleEs;
		if (resultado.equals("camConsecuIt"))
			return reCamConsecuIt;
		if (resultado.equals("camConsecuEs"))
			return reCamConsecuEs;
		if (resultado.equals("camConsecuCom"))
			return reCamConsecuCom;
		if (resultado.equals("camConsecuCon"))
			return reCamConsecuCon;
		if (resultado.equals("camActivaCom"))
			return reCamActivaCom;
		if (resultado.equals("camApariencia"))
			return reCamApariencia;
		return -1;
	}

}
